# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para pordede
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------

import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__category__ = "A"
__type__ = "generic"
__title__ = "Torrentestrenos"
__channel__ = "torrentestrenos"
__language__ = "ES"

host = "http://www.torrentestrenos.com"

DEBUG = config.get_setting("debug")



def isGeneric():
    return True

def login():
    
    url = "http://www.torrentestrenos.com/index.php"
    post = "login="+config.get_setting("torrentestrenosuser")+"&password="+config.get_setting("torrentestrenospassword")+"&Submit=ENTRAR"
    data = scrapertools.cache_page(url,post=post)



def mainlist(item):
    logger.info("pelisalacarta.torrentestrenos mainlist")
    
    itemlist = []
    
    if config.get_setting("torrentestrenosaccount")!="true":
        itemlist.append( Item( channel=__channel__ , title="Habilita tu cuenta en la configuracin..." , action="openconfig" , url="" , folder=False ) )
    else:
        login()
        
        itemlist.append( Item(channel=__channel__, title="Exterenos Cartelera" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_1-id_en_estrenos_de_cartelera.html", thumbnail="http://s6.postimg.org/7fpx8gnrl/tecartelerath.jpg", fanart="http://s6.postimg.org/c84bxn7td/tecartelera.jpg"))
        itemlist.append( Item(channel=__channel__, title="PelisMicroHD" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_41-id_en_peliculas_microhd.html", thumbnail="http://s6.postimg.org/copjk2vkh/temhdthu.jpg", fanart="http://s6.postimg.org/e8zgw7tch/temhdfan.jpg"))
        itemlist.append( Item(channel=__channel__, title="PelisBluray-rip" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_33-id_en_peliculas_bluray--rip.html", thumbnail="http://s6.postimg.org/wptvn19ap/teripthub.jpg", fanart="http://s6.postimg.org/j3t5uhro1/teripfan6.jpg"))
        itemlist.append( Item(channel=__channel__, title="PelisDvd-Rip" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_9-id_en_peliculas_dvd--rip.html", thumbnail="http://s6.postimg.org/gcaeasmkx/tethubdvdrip.jpg", fanart="http://s6.postimg.org/m6pak4h8x/tefandvdrip.jpg"))
        itemlist.append( Item(channel=__channel__, title="Series" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_10-id_en_series.html", thumbnail="http://s6.postimg.org/gl7gtt5xt/teserthub2.jpg", fanart="http://s6.postimg.org/oa4tcfzv5/teserfan.jpg"))
        itemlist.append( Item(channel=__channel__, title="SeriesHD" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_38-id_en_series_hd.html", thumbnail="http://s6.postimg.org/bk02sfyhd/tesehdth.jpg", fanart="http://s6.postimg.org/ralnszb69/teserhdfan.jpg" ))
        itemlist.append( Item(channel=__channel__, title="Documentales" , action="peliculas"           , url="http://www.torrentestrenos.com/ver_torrents_23-id_en_documentales.html", thumbnail="http://s6.postimg.org/5t5b0z13l/tedocuthub.jpg", fanart="http://s6.postimg.org/aqivm332p/tedocufan.jpg" ))
        itemlist.append( Item(channel=__channel__, action="search", title="Buscar...", url="", thumbnail="http://s6.postimg.org/42qvd88y9/tesearchfan.jpg", fanart="http://s6.postimg.org/x7p12vyvl/tesearchfan2.jpg"))
    
    
    return itemlist

def openconfig(item):
    if "xbmc" in config.get_platform() or "boxee" in config.get_platform():
        config.open_settings( )
    return []

def search(item,texto):
    logger.info("pelisalacarta.torrentestrenos search")
    texto = texto.replace(" ","+")
    
    item.url = "http://www.torrentestrenos.com/main.php?q=%s" % (texto)
    try:
        return buscador(item)
    # Se captura la excepcin, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []

    


    return itemlist

def buscador(item):
    logger.info("pelisalacarta.torrentstrenos buscador")
    itemlist = []

# Descarga la pgina
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
    
    #<div class="torrent-container-2 clearfix"><img class="torrent-image" src="uploads/torrents/images/thumbnails2/4441_step--up--all--in----blurayrip.jpg" alt="Imagen de Presentaci&oacute;n" /><div class="torrent-info"><h4><a href ="/descargar_torrent_27233-id_step_up_all_in_microhd_1080p_ac3_5.1--castellano--ac3_5.1_ingles_subs.html">Step Up All In MicroHD 1080p AC3 5.1-Castellano-AC3 5.1 Ingles Subs</a> </h4><p>19-12-2014</p><p>Subido por: <strong>TorrentEstrenos</strong> en <a href="/ver_torrents_41-id_en_peliculas_microhd.html" title="Peliculas MICROHD">Peliculas MICROHD</a><br />Descargas <strong><a href="#" style="cursor:default">46</a></strong></p><a class="btn-download" href ="/descargar_torrent_27233-id_step_up_all_in_microhd_1080p_ac3_5.1--castellano--ac3_5.1_ingles_subs.html">Descargar</a></div></div>
    
    patron =  '<div class="torrent-container-2 clearfix">.*?'
    patron += 'src="([^"]+)".*? '
    patron += 'href ="([^"]+)".*?'
    patron += '>([^<]+)</a>.*?'
    patron += '<p>([^<]+)</p>'
    
    
    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)
    
    for scrapedthumbnail, scrapedurl, scrapedtitulo, scrapedcreatedate in matches:
        scrapedtitulo = scrapedtitulo + "(Torrent:" + scrapedcreatedate + ")"
        scrapedthumbnail = "http://www.torrentestrenos.com/" + scrapedthumbnail
        scrapedurl = "http://www.torrentestrenos.com" + scrapedurl
        
        
        itemlist.append( Item(channel=__channel__, title=scrapedtitulo, url=scrapedurl, action="findvideos", thumbnail=scrapedthumbnail, fanart="http://s6.postimg.org/44tc7dtg1/tefanartgeneral.jpg", fulltitle=scrapedtitulo, folder=True) )

    return itemlist

def peliculas(item):
    logger.info("pelisalacarta.torrentstrenos peliculas")
    itemlist = []
    
    # Descarga la pgina
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
    
    #<div class="torrent-container-2 clearfix"><img class="torrent-image" src="uploads/torrents/images/thumbnails2/4441_step--up--all--in----blurayrip.jpg" alt="Imagen de Presentaci&oacute;n" /><div class="torrent-info"><h4><a href ="/descargar_torrent_27233-id_step_up_all_in_microhd_1080p_ac3_5.1--castellano--ac3_5.1_ingles_subs.html">Step Up All In MicroHD 1080p AC3 5.1-Castellano-AC3 5.1 Ingles Subs</a> </h4><p>19-12-2014</p><p>Subido por: <strong>TorrentEstrenos</strong> en <a href="/ver_torrents_41-id_en_peliculas_microhd.html" title="Peliculas MICROHD">Peliculas MICROHD</a><br />Descargas <strong><a href="#" style="cursor:default">46</a></strong></p><a class="btn-download" href ="/descargar_torrent_27233-id_step_up_all_in_microhd_1080p_ac3_5.1--castellano--ac3_5.1_ingles_subs.html">Descargar</a></div></div>
    
    patron =  '<div class="torrent-container-2 clearfix">.*?'
    patron += 'src="([^"]+)".*? '
    patron += 'href ="([^"]+)".*?'
    patron += '>([^<]+)</a>.*?'
    patron += '<p>([^<]+)</p>'
    
    
    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)
    
    for scrapedthumbnail, scrapedurl, scrapedtitulo, scrapedcreatedate in matches:
        scrapedtitulo = scrapedtitulo + "(Torrent:" + scrapedcreatedate + ")"
        scrapedthumbnail = "http://www.torrentestrenos.com/" + scrapedthumbnail
        scrapedurl = "http://www.torrentestrenos.com" + scrapedurl
        
        
        itemlist.append( Item(channel=__channel__, title=scrapedtitulo, url=scrapedurl, action="findvideos", thumbnail=scrapedthumbnail, fulltitle=scrapedtitulo, fanart="http://s6.postimg.org/44tc7dtg1/tefanartgeneral.jpg", folder=True) )
    
   

## Extrae el paginador ##
# a class="paginator-items" href="/ver_torrents_41-id_en_peliculas_microhd_pag_1.html" title="Pagina de torrent 1">1</a>
    if "_pag_" in item.url:
       current_page_number = int(scrapertools.get_match(item.url,'_pag_(\d+)'))
       item.url = re.sub(r"_pag_\d+","_pag_%s",item.url)
    else:
        current_page_number = 1
        item.url = item.url.replace(".html","_pag_%s.html")

    next_page_number = current_page_number + 1
    next_page = item.url % (next_page_number)
    
    title= "[COLOR green]Pagina siguiente>>[/COLOR]"
    if next_page.replace("http://www.torrentestrenos.com","") in data:
        itemlist.append( Item(channel=__channel__, title=title, url=next_page, action="peliculas", thumbnail="http://s6.postimg.org/4hpbrb13l/texflecha2.png", fanart="http://s6.postimg.org/44tc7dtg1/tefanartgeneral.jpg", folder=True) )


    return itemlist

def findvideos(item):
    logger.info("pelisalacarta.torrentestrenos findvideos")
    itemlist = []
    
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
    

    patron = '<img class="torrent-image.*? '
    patron+= 'src="([^"]+)".*?'
    patron+= '<h4>([^<]+)</h4>.*?'
    patron+= '</p><p>([^<]+)</p><p>.*?'
    patron+= 'href =".*?l=([^"]+)"'
   
    
    matches = re.compile(patron,re.DOTALL).findall(data)
    
    for scrapedthumbnail, scrapedtitulo, scrapedplot, scrapedurl in matches:
        
        scrapedthumbnail = "http://www.torrentestrenos.com/" + scrapedthumbnail
        scrapedplot = scrapedplot.replace("&aacute;","a")
        scrapedplot = scrapedplot.replace("&iacute;","i")
        scrapedplot = scrapedplot.replace("&eacute;","e")
        scrapedplot = scrapedplot.replace("&oacute;","o")
        scrapedplot = scrapedplot.replace("&uacute;","u")
        scrapedplot = scrapedplot.replace("&ntilde;","")
        scrapedplot = scrapedplot.replace("&Aacute;","A")
        scrapedplot = scrapedplot.replace("&Iacute;","I")
        scrapedplot = scrapedplot.replace("&Eacute;","E")
        scrapedplot = scrapedplot.replace("&Oacute;","O")
        scrapedplot = scrapedplot.replace("&Uacute;","U")
        scrapedplot = scrapedplot.replace("&Ntilde;","")

        
        
        
        itemlist.append( Item(channel=__channel__, title =scrapedtitulo , url=scrapedurl, action="play", server="torrent", thumbnail=scrapedthumbnail, fanart=item.thumbnail, plot=scrapedplot, folder=False) )

    return itemlist




    